#include <iostream>
#include <vector>
#include <math.h>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    float n;
};

Input
input_data() {
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cerr << "Enter number " << i+1 << ": ";
        cin >> in.numbers[i];}
    cerr << "Enter bin count: ";
    cin >> in.bin_count;

    in.n = 0;
    if (in.bin_count==0){
        in.bin_count = sqrt(number_count);
        in.n = 1;
        if (in.bin_count > 25){
            in.bin_count = 1 + log2(number_count);
            in.n = 2;}}

    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
min = numbers[0];
max = numbers[0];
for (double x : numbers) {
    if (x < min) {
        min = x;
    }
    else if (x > max) {
        max = x;
    }
}
}

vector<size_t>
make_histogram(const vector<double>& numbers, size_t bin_count){

    double min, max;
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);

    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }

    }
    return bins;
}

void
show_histogram_text(const vector<size_t>& bins, size_t bin_count, float n){
    if (n != 0){
        cout << "bin count = " << bin_count;
        if (n == 1)
            cout << " using 1st" << '\n';
        else
            cout << " using 2nd" << '\n';}
    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i]<100)
            cout << " ";
        if (bins[i]<10)
            cout << " ";
        cout << bins[i] << "|";
        for (size_t j = 0; j < bins[i]; j++){
            cout << "*";}
        cout << '\n';}
}
int main()
{

    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count, in.n);

    return 0;
}
